Index: lib/spatial/mapbuilder/lib/widget/WidgetBase.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/WidgetBase.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/WidgetBase.js	(revision 4307)
@@ -1,18 +1,11 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: WidgetBase.js 3880 2008-02-27 15:37:08Z gjvoosten $
 */
 
 /**
- * Base Class for widgets.  Associates a node on the page with a stylesheet and
- * model.  All widgets must extend this base class.
- * Defines the default paint() method for all widgets which is where the 
- * stylesheet is applied to the model XML document.
- * To override widget.paint(), define it before calling this constructor.
- * The stylesheet URL defaults to "widget/<widgetName>.xsl" if it is not defined
- * in config file.  Set a stylesheet property containing an XSL URL in config
- * to customize the stylesheet used.
- * All stylesheets will have "modelId" and "widgetId" parameters set when called.
+ * Base Class for widgets. All widgets must extend this base class.
+ * Defines the default prePaint() and postPaint() methods for all widgets.
  *
  * @constructor
  * @author Mike Adair 
@@ -24,43 +17,56 @@
   this.model = model;
   this.widgetNode = widgetNode;
 //alert(widgetNode.nodeName);
+	var templatedWidget = false;
+	if(model.modelNode.attributes.getNamedItem("createByTemplate") && model.modelNode.attributes.getNamedItem("createByTemplate").nodeValue=='true'){
+		widgetNode.setAttribute("id","MbWidget_" + mbIds.getId());
+	  templatedWidget = true;
+  }
 
   /** Widget's Id defined in the Config (required) */
   if (widgetNode.attributes.getNamedItem("id")) {
     this.id = widgetNode.attributes.getNamedItem("id").nodeValue;
   } else {
-    alert("id required for object:" + widgetNode.nodeName );
+    alert(mbGetMessage("idRequired", widgetNode.nodeName));
   }
+  
+  /**
+   * Convenient access to Mapbuilder.getProperty
+   * @param property property to get
+   * @param default value to use if property is not set
+   * @return the value for the property
+   */
+  this.getProperty = function(property, defaultValue) {
+    return Mapbuilder.getProperty(widgetNode, property, defaultValue);
+  }
 
   //allow the widget output to be replaced on each paint call
-  this.autoRefresh = true;
-  var outputNode = widgetNode.selectSingleNode("mb:outputNodeId");
-  if ( outputNode ) {
-    this.outputNodeId = outputNode.firstChild.nodeValue;
-    this.autoRefresh = false;
-  } else {
-    this.outputNodeId = "MbWidget_" + mbIds.getId();
+  if(templatedWidget){
+    this.outputNodeId = this.id;
+  }else {
+    this.outputNodeId = this.getProperty("mb:outputNodeId", "MbWidget_" + mbIds.getId());
   }
 
   //until htmlTagNode becomes required allow setting of it by widget id
   if (!this.htmlTagId) {
-    var htmlTagNode = widgetNode.selectSingleNode("mb:htmlTagId");
-    if (htmlTagNode) {
-      this.htmlTagId = htmlTagNode.firstChild.nodeValue;
-    } else {
-      this.htmlTagId = this.id;
-    }
+    this.htmlTagId = this.getProperty("mb:htmlTagId", this.id);
   }
 
-  // Node in main HTML to attach widget to.
-  this.node = document.getElementById(this.htmlTagId);
-  if(!this.node) {
-    //alert("htmlTagId: "+this.htmlTagId+" for widget "+widgetNode.nodeName+" not found in config");
+  this.getNode = function() {
+    // Node in main HTML to attach widget to.
+    var node = document.getElementById(this.htmlTagId);
+    if(!node) {
+      //alert("htmlTagId: "+this.htmlTagId+" for widget "+widgetNode.nodeName+" not found in config");
+    }
+    return node;
   }
 
-  //set an empty debug property in config to see inputs and outputs of stylehseet
-  if ( widgetNode.selectSingleNode("mb:debug") ) this.debug=true;
+  //allow widgets to not automatically update themseleves in certain circumstances (see layerControl for example)
+  this.autoRefresh = Mapbuilder.parseBoolean(this.getProperty("mb:autoRefresh", true));
 
+  //set a debug property in config to see inputs and outputs of stylehseet
+  this.debug = Mapbuilder.parseBoolean(this.getProperty("mb:debug", false));
+
   /**
    * Initialize dynamic properties.set the target model
    * @param toolRef Pointer to this object.
@@ -67,11 +73,11 @@
    */
   this.initTargetModel = function(objRef) {
     //set the target model
-    var targetModel = objRef.widgetNode.selectSingleNode("mb:targetModel");
+    var targetModel = objRef.getProperty("mb:targetModel");
     if (targetModel) {
-      objRef.targetModel = eval("config.objects."+targetModel.firstChild.nodeValue);
+      objRef.targetModel = window.config.objects[targetModel];
       if ( !objRef.targetModel ) {
-        alert("error finding targetModel:" + targetModel.firstChild.nodeValue + " for:" + objRef.id);
+        alert(mbGetMessage("noTargetModelWidget", targetModel, objRef.id));
       }
     } else {
       objRef.targetModel = objRef.model;
@@ -102,9 +108,10 @@
    * @param objRef Pointer to this object.
    */ 
   this.clearWidget = function(objRef) {
-    //with objRef.node remove child
+    //with node remove child
     var outputNode = document.getElementById( objRef.outputNodeId );
-    if (outputNode) objRef.node.removeChild(outputNode);
+    var node = objRef.getNode();
+    if (node && outputNode) node.removeChild(outputNode);
   }
   this.model.addListener("newModel",this.clearWidget, this);
 }
Index: lib/spatial/mapbuilder/lib/widget/OpenLSForm.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/OpenLSForm.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/OpenLSForm.js	(revision 4307)
@@ -0,0 +1,71 @@
+/*
+Description: Display a form for OpenLS geocoding request
+Author:      Steven Ottens AT geodan.nl
+Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: OpenLSForm.js 3879 2008-02-27 14:20:29Z gjvoosten $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+
+/**
+ * Widget to display the OpenLS request form
+ *
+ * @constructor
+ * @base WidgetBaseXSL
+ * @param widgetNode This widget's object node from the configuration document.
+ * @param model The model that this widget is a view of.
+ */
+
+function OpenLSForm(widgetNode, model) {
+  WidgetBaseXSL.apply(this,new Array(widgetNode, model));
+
+	this.defaultModelUrl=this.getProperty("mb:defaultModelUrl");
+	this.geocodeServerUrl=this.getProperty("mb:geocodeServerUrl");
+
+  this.xsl=new XslProcessor(baseDir+"/tool/xsl/ols_GeocodeRequest.xsl");	
+	/**
+	* handles the submission of the form
+	*/
+	this.submitForm = function(objRef) {
+		//Parse the form
+		var geoForm = document.getElementById(this.formName);
+    pc = geoForm.pcValue.value;
+    street = geoForm.streetValue.value;
+    number = geoForm.numberValue.value;
+    city = geoForm.cityValue.value;
+    municipality = geoForm.municipalityValue.value;
+    country =geoForm.countryValue.value;
+		
+		//fill the form output into the xsl
+		if(pc) objRef.xsl.setParameter("postalCode", pc);
+    if(street) objRef.xsl.setParameter("street", street);
+    if(number) objRef.xsl.setParameter("number", number);
+    if(city) objRef.xsl.setParameter("municipalitySubdivision", city);
+    if(municipality) objRef.xsl.setParameter("municipality", municipality);
+    if(country) objRef.xsl.setParameter("countryCode", country);
+    if(!country) {
+      alert(mbGetMessage("noCountryCode"));
+      return;
+    }
+		//no values entered, bail out
+		if(!municipality && !city && !number && !street && !pc) {
+			alert(mbGetMessage("atLeastOneValue"));
+			return;
+		}
+		
+		//do the actual request
+    objRef.requestModel = objRef.xsl.transformNodeToObject(this.model.doc);
+    objRef.httpPayload = new Object();
+    objRef.httpPayload.url = objRef.geocodeServerUrl;
+    objRef.httpPayload.method="post";
+    objRef.httpPayload.postData=objRef.requestModel;
+    objRef.targetModel.newRequest(objRef.targetModel,objRef.httpPayload);  
+  }
+
+  //set some properties for the form output
+  //allow it to have a different form name
+  this.formName = this.getProperty("mb:formName", "OpenLSForm_" + mbIds.getId());
+  this.stylesheet.setParameter("formName", this.formName);
+}
+
Index: lib/spatial/mapbuilder/lib/widget/Legend.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Legend.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/Legend.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Legend.js 3887 2008-02-27 18:18:53Z ahocevar $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -17,6 +17,11 @@
 function Legend(widgetNode, model) {
   WidgetBaseXSL.apply(this,new Array(widgetNode, model));
 
+  this.model.addListener("deleteLayer",this.refresh, this);
+  this.model.addListener("moveLayerUp",this.refresh, this);
+  this.model.addListener("moveLayerDown",this.refresh, this);
+  if (this.autoRefresh) this.model.addListener("addLayer",this.refresh, this);
+
   /**
    * Override of widget prepaint to set some stylesheet parameters including 
    * featureName (for OWS Context) and hidden attribute.
@@ -27,18 +32,36 @@
       objRef.stylesheet.setParameter("featureName", objRef.model.featureName );
       objRef.stylesheet.setParameter("hidden", objRef.model.getHidden(objRef.model.featureName).toString() );
     }
+    objRef.visibleLayer = Mapbuilder.getProperty(objRef.model.doc, objRef.model.nodeSelectXpath+"[@hidden='0' and @opaque='1']/wmc:Name");
   }
 
-  /**
-   * @param objRef Pointer to this object.
-   * @param layer The selected layer.
-   */
-  this.selectLayer = function(objRef,layer) {
-    objRef.model.setParam('selectedLayer',layer);
-  }
+}
 
-  this.model.addListener("deleteLayer",this.paint, this);
-  this.model.addListener("moveLayerUp",this.paint, this);
-  this.model.addListener("moveLayerDown",this.paint, this);
-  this.model.addListener("addLayer",this.paint, this);
+/**
+ * Listener method to paint this widget
+ * @param layerName  the name of the layer to highlight
+ */
+Legend.prototype.refresh = function(objRef, layerName) {
+  objRef.paint(objRef, objRef.id);
 }
+
+/**
+ * Controller method to select a layer
+ * @param objRef Pointer to this object.
+ * @param layer The selected layer.
+ */
+Legend.prototype.selectLayer = function(objRef,layer) {
+  objRef.model.setParam('selectedLayer',layer);
+}
+
+/**
+ * Controller method to select a layer
+ * @param objRef Pointer to this object.
+ * @param layer The selected layer.
+ */
+Legend.prototype.swapOpaqueLayer = function(layer) {
+  this.model.setHidden(this.visibleLayer, true);
+  this.model.setHidden(layer, false);
+  this.visibleLayer = layer;
+}
+
Index: lib/spatial/mapbuilder/lib/widget/WfsGetFeature.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/WfsGetFeature.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/WfsGetFeature.js	(revision 4307)
@@ -1,11 +1,12 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
 Dependancies: Context
-$Id$
+$Id: WfsGetFeature.js 3899 2008-03-03 10:33:30Z ahocevar $
 */
 
 // Ensure this object's dependancies are loaded.
-mapbuilder.loadScript(baseDir+"/tool/ButtonBase.js");
+mapbuilder.loadScript(baseDir+"/widget/ButtonBase.js");
+mapbuilder.loadScript(baseDir+"/util/openlayers/OpenLayers.js");
 /**
  * Builds then sends a WFS GetFeature GET request based on the WMC
  * coordinates and click point.
@@ -18,55 +19,110 @@
 function WfsGetFeature(widgetNode, model) {
   // Extend ButtonBase
   ButtonBase.apply(this, new Array(widgetNode, model));
-  this.tolerance= widgetNode.selectSingleNode('mb:tolerance').firstChild.nodeValue;
-  this.typeName= widgetNode.selectSingleNode('mb:typeName').firstChild.nodeValue;
-  this.webServiceUrl= widgetNode.selectSingleNode('mb:webServiceUrl').firstChild.nodeValue;
-  this.httpPayload=new Object();
-  this.httpPayload.method="get";
-  this.httpPayload.postData=null;
-  this.trm=widgetNode.selectSingleNode("mb:transactionResponseModel").firstChild.nodeValue;
 
+  this.widgetNode = widgetNode;
+  // id of the transactionResponseModel
+  this.trm = this.getProperty("mb:transactionResponseModel");
+  this.httpPayload = new Object({
+    method: "get",
+    postData: null
+  });
+  this.typeName = this.getProperty('mb:typeName');
+  this.maxFeatures = this.getProperty('mb:maxFeatures', 1);
+  this.webServiceUrl= this.getProperty('mb:webServiceUrl');
+  this.webServiceUrl += this.webServiceUrl.indexOf("?") > -1 ? '&' : '?';
+  this.webServiceSrs= new OpenLayers.Projection(this.getProperty('mb:webServiceSrs', "EPSG:4326"));
+  
   // override default cursor by user
   // cursor can be changed by spefying a new cursor in config file
   this.cursor = "pointer"; 
 
-  /**
-   * Open window with query info.
-   * This function is called when user clicks map with Query tool.
-   * @param objRef      Pointer to this GetFeatureInfo object.
-   * @param targetNode  The node for the enclosing HTML tag for this widget.
-   */
-  this.doAction = function(objRef,targetNode) {
-    if (objRef.enabled) {
-      extent=objRef.targetModel.extent;
-      point=extent.getXY(targetNode.evpl);
-      xPixel=extent.res[0]*objRef.tolerance;
-      yPixel=extent.res[1]*objRef.tolerance;
-      bbox=(point[0]-xPixel)+","+(point[1]-yPixel)+","+(point[0]+xPixel)+","+(point[1]+yPixel);
-      objRef.httpPayload.url=objRef.webServiceUrl+"?request=GetFeature&typeName="+objRef.typeName+"&bbox="+bbox;
+  this.createControl = function(objRef) {
+  	var transactionResponseModel = config.objects[objRef.trm];
+  	
+    var Control = OpenLayers.Class( OpenLayers.Control, {
+      CLASS_NAME: 'mbControl.WfsGetFeature',
+      type: OpenLayers.Control.TYPE_TOOL, // constant from OpenLayers.Control
+  	  tolerance: new Number(objRef.getProperty('mb:tolerance')),
+  	  httpPayload: objRef.httpPayload,
+  	  maxFeatures: objRef.maxFeatures,
+  	  webServiceUrl: objRef.webServiceUrl,
+  	  transactionResponseModel: transactionResponseModel,
+  	  
+      draw: function() {
+        this.handler = new OpenLayers.Handler.Box( this,
+          {done: this.selectBox}, {keyMask: this.keyMask} );
+      },
+      
+      selectBox: function (position) {
+        var bounds, minXY, maxXY;
+        if (position instanceof OpenLayers.Bounds) {
+        // it's a box
+          minXY = this.map.getLonLatFromPixel(
+            new OpenLayers.Pixel(position.left, position.bottom));
+          maxXY = this.map.getLonLatFromPixel(
+            new OpenLayers.Pixel(position.right, position.top));
+        } else {
+        // it's a pixel
+          minXY = this.map.getLonLatFromPixel(
+            new OpenLayers.Pixel(position.x-this.tolerance, position.y+this.tolerance));
+          maxXY = this.map.getLonLatFromPixel(
+            new OpenLayers.Pixel(position.x+this.tolerance, position.y-this.tolerance));
+        }
+        
+        bounds = new OpenLayers.Bounds(minXY.lon, minXY.lat, maxXY.lon, maxXY.lat);
+        if (this.map.projection.projCode != this.objRef.webServiceSrs.projCode) {
+          bounds.transform(this.map.projection, this.objRef.webServiceSrs);
+        }
 
-      // Model that will be populated with the WFS response.
-      if (!objRef.transactionResponseModel){
-        objRef.transactionResponseModel=eval("config.objects."+objRef.trm);
-        //objRef.transactionResponseModel.addListener("loadModel",objRef.handleResponse, objRef);
+      var typeName = objRef.typeName;
+
+      if (!typeName) {
+        var queryList=objRef.targetModel.getQueryableLayers();
+        if (queryList.length==0) {
+          alert(mbGetMessage("noQueryableLayers"));
+          return;
+        }
+        else {
+          typeName = "";
+          for (var i=0; i<queryList.length; ++i) {
+            var layerNode = queryList[i];
+            
+            // Get the name of the layer
+            var layerName = layerNode.selectSingleNode("wmc:Name");
+            layerName=(layerName)?getNodeValue(layerName):"";
+
+            // Get the layerId. Fallback to layerName if non-existent
+            var layerId = layerNode.getAttribute("id") || layerName;
+
+            var hidden = objRef.targetModel.getHidden(layerId);
+            if (hidden == 0) { //query only visible layers
+              if (typeName != "") {
+                typeName += ",";
+              }
+              typeName += layerName;
+            }
+          }
+        }
       }
-      objRef.transactionResponseModel.newRequest(objRef.transactionResponseModel,objRef.httpPayload);
-    }
-  }
-  
 
-  /**
-   * Register for mouseUp events.
-   * @param objRef  Pointer to this object.
-   */
-  this.setMouseListener = function(objRef) {
-    if (objRef.mouseHandler) {
-      objRef.mouseHandler.model.addListener('mouseup',objRef.doAction,objRef);
-    }
-    objRef.context=objRef.widgetNode.selectSingleNode("mb:context");
-    if (objRef.context){
-      objRef.context=eval("config.objects."+objRef.context.firstChild.nodeValue);
-    }
+      if (typeName=="") {
+        alert(mbGetMessage("noQueryableLayersVisible"));
+        return;
+      }
+
+        // now create request url
+        this.httpPayload.url = this.webServiceUrl+OpenLayers.Util.getParameterString({
+          SERVICE: "WFS",
+          VERSION: "1.0.0",
+          REQUEST: "GetFeature",
+          TYPENAME: typeName,
+          MAXFEATURES: this.maxFeatures,
+          BBOX: bounds.toBBOX()
+        });
+        this.transactionResponseModel.newRequest(this.transactionResponseModel, this.httpPayload);
+      }
+    });
+    return Control;
   }
-  config.addListener( "loadModel", this.setMouseListener, this );
 }
Index: lib/spatial/mapbuilder/lib/widget/Widget.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Widget.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/Widget.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Widget.js 3091 2007-08-09 12:21:54Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -8,10 +8,10 @@
 
 /**
  * Generic Widget object for widgets where no specialization is required.  
- * This is just an instance of a abstract WidgetBase object.
+ * This is just an instance of a abstract WidgetBaseXSL object.
  * This widget requires a <stylesheet> property in the config file.
  * @constructor
- * @base WidgetBase
+ * @base WidgetBaseXSL
  * @author Cameron Shorter cameronATshorter.net
  * @param widgetNode  The widget's XML object node from the configuration document.
  * @param model       The model object that this widget belongs to.
Index: lib/spatial/mapbuilder/lib/widget/FeatureList.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/FeatureList.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/FeatureList.js	(revision 4307)
@@ -1,15 +1,15 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: FeatureList.js 3091 2007-08-09 12:21:54Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
-mapbuilder.loadScript(baseDir+"/widget/WidgetBase.js");
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
 
 /**
  * Functions to render and update a FeatureList from GML.
  * @constructor
- * @base WidgetBase
+ * @base WidgetBaseXSL
  * @author Cameron Shorter
  * @param widgetNode  The widget's XML object node from the configuration document.
  * @param model       The model object that this widget belongs to.
Index: lib/spatial/mapbuilder/lib/widget/ModelStatus.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/ModelStatus.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/ModelStatus.xsl	(revision 4307)
@@ -1,35 +1,2 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<xsl:stylesheet version="1.0" 
-    xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" 
-    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
-
-<!--
-Description: Widget to display the status of a model
-Author:      Mike Adair
-Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
-
-$Id$
--->
-
-  <xsl:output method="xml" encoding="utf-8"/>
-
-  <!-- The common params set for all widgets -->
-  <xsl:param name="lang">en</xsl:param>
-  <xsl:param name="modelId"/>
-  <xsl:param name="modelTitle"/>
-  <xsl:param name="widgetId"/>
-
-  <!-- Text params for this widget -->
-  <xsl:param name="title"/>
-  
-  <!-- The name of the form for coordinate output -->
-  <xsl:param name="statusMessage"/>
-
-  <!-- Main html -->
-  <xsl:template match="/">
-    <DIV>
-      <xsl:value-of select="$title"/><xsl:value-of select="$modelTitle"/><xsl:value-of select="$statusMessage"/>
-    </DIV>
-  </xsl:template>
-  
-</xsl:stylesheet>
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"><xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/><xsl:param name="lang">en</xsl:param><xsl:param name="modelId"/><xsl:param name="modelTitle"/><xsl:param name="widgetId"/><xsl:param name="title"/><xsl:param name="statusMessage"/><xsl:template match="/"><DIV><xsl:value-of select="$title"/><xsl:value-of select="$modelTitle"/><xsl:value-of select="$statusMessage"/></DIV></xsl:template></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/TabbedContent.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/TabbedContent.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/TabbedContent.xsl	(revision 4307)
@@ -1,40 +1,2 @@
-<?xml version="1.0" encoding="ISO-8859-1"?>
-
-<!--
-Description: a TabbedContent node from config to output some tabs, 
-              this requires a CSS file, see skin/default/tablist.css
-Author:      adair/stella
-Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
-
-$Id$
-$Name$
--->
-
-<xsl:stylesheet version="1.0" 
-    xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" 
-    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
-
-  <xsl:output method="xml"/>
-  <xsl:strip-space elements="*"/>
-
-  <!-- The coordinates of the DHTML Layer on the HTML page -->
-  <xsl:param name="modelId"/>
-  <xsl:param name="widgetId"/>
-
-  <!-- these handled outside of the stylesheet -->
-  <xsl:template match="mb:TabbedContent">
-    <ul class="tablist">
-      <xsl:apply-templates select="mb:tab"/>
-    </ul>
-  </xsl:template>
-  
-  <xsl:template match="mb:tab">
-    <xsl:variable name="tabWidgetId" select="."/>
-    <li>
-      <a href="javascript:config.objects.{$widgetId}.selectTab(config.objects.{$tabWidgetId})" id="{$widgetId}_{$tabWidgetId}">
-        <xsl:value-of select="@label"/>
-      </a>
-    </li>
-  </xsl:template>
-  
-</xsl:stylesheet>
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"><xsl:output method="xml" omit-xml-declaration="yes"/><xsl:strip-space elements="*"/><xsl:param name="modelId"/><xsl:param name="widgetId"/><xsl:template match="mb:TabbedContent"><ul class="tablist"><xsl:apply-templates select="mb:tab"/></ul></xsl:template><xsl:template match="mb:tab"><xsl:variable name="tabWidgetId" select="."/><li><xsl:if test="@disabled='true'"><xsl:attribute name="class">disabled</xsl:attribute></xsl:if><a href="javascript:config.objects.{$widgetId}.selectTab(config.objects.{$tabWidgetId})" id="{$widgetId}_{$tabWidgetId}"><xsl:value-of select="@label"/></a></li></xsl:template></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/MapScaleText.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/MapScaleText.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/MapScaleText.xsl	(revision 4307)
@@ -1,37 +1,2 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<xsl:stylesheet version="1.0" 
-    xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" 
-    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
-
-<!--
-Description: Output a form for displaying and setting the map scale denominator
-Author:      Mike Adair
-Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
-
-$Id$
--->
-
-  <xsl:output method="xml" encoding="utf-8"/>
-
-  <!-- The common params set for all widgets -->
-  <xsl:param name="lang">en</xsl:param>
-  <xsl:param name="modelId"/>
-  <xsl:param name="widgetId"/>
-
-  <!-- The name of the form for coordinate output -->
-  <xsl:param name="mapScale"/>
-  <xsl:param name="mapScaleLabel">scale 1:</xsl:param>
-  <xsl:param name="formName">MapScaleTextForm</xsl:param>
-
-  <!-- Main html -->
-  <xsl:template match="/">
-    <div>
-      <form name="{$formName}" id="{$formName}" onsubmit="return config.objects.{$widgetId}.submitForm()">
-        <xsl:value-of select="$mapScaleLabel"/><input name="mapScale" type="text" size="10" value="{$mapScale}"/>
-        <!--input type="submit" value="set scale"/-->
-        <!--a href="javascript:config.{$modelId}.{$widgetId}.submitForm();">set new scale</a-->
-      </form>
-    </div>
-  </xsl:template>
-  
-</xsl:stylesheet>
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"><xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/><xsl:param name="lang">en</xsl:param><xsl:param name="modelId"/><xsl:param name="widgetId"/><xsl:param name="mapScale"/><xsl:param name="mapScaleLabel">scale 1:</xsl:param><xsl:param name="formName">MapScaleTextForm</xsl:param><xsl:template match="/"><div><form name="{$formName}" id="{$formName}" onsubmit="return config.objects.{$widgetId}.submitForm()"><xsl:value-of select="$mapScaleLabel"/><input name="mapScale" type="text" size="10" value="{$mapScale}"/></form></div></xsl:template></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/LegendGraphic.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/LegendGraphic.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/LegendGraphic.js	(revision 4307)
@@ -0,0 +1,34 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: LegendGraphic.js 3010 2007-07-25 14:09:06Z steven $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+
+/**
+ * Functions to render and update a Legend from a Web Map Context.
+ * 
+ * WARNING: In most cases you probably want either Legend.js or LayerControl.js they
+ * both display the legend graphic per layer.
+ * @deprecated
+ * @constructor
+ * @base WidgetBaseXSL
+ * @author Cameron Shorter cameronATshorter.net
+ * @param widgetNode  The widget's XML object node from the configuration document.
+ * @param model       The model object that this widget belongs to.
+ */
+function LegendGraphic(widgetNode, model) {
+  WidgetBaseXSL.apply(this,new Array(widgetNode, model));
+
+  this.model.addListener("hidden",this.refresh, this);
+}
+
+/**
+ * Listener method to paint this widget
+ * @param layerName  the name of the layer to highlight
+ */
+LegendGraphic.prototype.refresh = function(objRef, layerName) {
+  objRef.paint(objRef, objRef.id);
+}
+
Index: lib/spatial/mapbuilder/lib/widget/CollectionList.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/CollectionList.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/CollectionList.js	(revision 4307)
@@ -2,7 +2,7 @@
 Author:       Cameron Shorter cameronAtshorter.net
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 
-$Id$
+$Id: CollectionList.js 3888 2008-02-27 18:25:45Z ahocevar $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -11,8 +11,10 @@
 /**
  * A widget to display a list of context docs to pick from.  This is a view of 
  * a Context Collection as specified in the OGC Context specification.
+ * The default xsl stylesheet for this widget also uses the switchMap
+ * function, which allows to switch to a different map context.
  * @constructor
- * @base WidgetBase
+ * @base WidgetBaseXSL
  * @param widgetNode  The widget's XML object node from the configuration document.
  * @param model       The model object that this widget belongs to.
  */
@@ -20,4 +22,44 @@
 function CollectionList(widgetNode, model) {
   WidgetBaseXSL.apply(this,new Array(widgetNode, model));
 
+  /**
+   * Switch to another map context, keeping the current extent.
+   * @param objRef this widget
+   * @modelUrl the URL of the context we want to switch to.
+   */
+  this.switchMap = function(objRef, modelUrl) {
+    // save the current extent
+    objRef.extent = objRef.targetModel.map.getExtent();
+    objRef.srs = objRef.targetModel.getSRS();
+    objRef.scale = objRef.targetModel.map.getScale();
+   
+    objRef.targetModel.addListener( "loadModel", objRef.setExtent, objRef );
+    config.loadModel( objRef.targetModel.id, modelUrl );
+  }
+  
+  /**
+   * Sets the extent of the map that we just switched to.
+   * Called when the map is reloaded with the new context.
+   * @param objRef this widget
+   */
+  this.setExtent = function (objRef) {
+    objRef.targetModel.removeListener( "loadModel", objRef.setExtent, objRef );
+
+    var bbox = objRef.extent.toBBOX().split(/,/);  
+    if (objRef.targetModel.getSRS().toUpperCase() != objRef.srs.toUpperCase()) {
+      var targetProj = new OpenLayers.Projection(objRef.targetModel.getSRS());
+      var srcProj = new OpenLayers.Projection(objRef.srs);
+    	var ptLL=new OpenLayers.Geometry.Point(bbox[0],bbox[1]);
+    	var ptUR=new OpenLayers.Geometry.Point(bbox[2],bbox[3]);
+  		ptLL.transform(srcProj, targetProj);
+	    ptUR.transform(srcProj, targetProj);
+      objRef.extent = new OpenLayers.Bounds(ptLL.x, ptLL.y, ptUR.x, ptUR.y);
+    }
+    if (objRef.targetModel.map.getExtent().containsBounds(objRef.extent, false, false)) {
+      objRef.targetModel.map.zoomToExtent(objRef.extent);
+      if (!objRef.targetModel.map.fractionalZoom && objRef.targetModel.map.getScale() > objRef.scale) {
+        objRef.targetModel.map.zoomIn();
+      }
+    }
+  }
 }
